<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2003 Administrator (admin@email.test)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'spamshield' for the 'spamshield' extension.
 *
 * This modul will modify the forms on a page befor output.
 * According to TS-Configuration different changes are possible:
 * 1) Java-Script redirect
 * 2) Add-Honey-Pot field
 * 3) Rename all form-fields and include one hidden field to transfer the original names for reconstruction in the varAnalyzer-Class
 * 4) include a hidden field for Time-Stamp
 * 5) ...
 *
 * @author        Ronald Steiner <ronald.steiner@googlemail.com>
 *                initial testing with fe hook
 */

require_once (PATH_tslib."class.tslib_pibase.php");
require_once (PATH_tslib."class.tslib_content.php");

if(t3lib_extMgm::isLoaded('sourceopt', 0)) { // load sourceopt
	require_once(t3lib_extMgm::extPath('sourceopt').'pi1/class.tx_sourceopt_pi1.php');
}


class tx_spamshield_pi2 extends tslib_pibase {
        
	var $prefixId = "tx_spamshield_pi2";                // Same as class name
	var $scriptRelPath = "pi2/class.tx_spamshield_pi2.php";        // Path to this script relative to the extension dir.
	var $extKey = "spamshield";        // The extension key.
        
	var $html;   		// HTML code of the page / content element
	var $orgForms;  	// The original Forms
	var $newForms;  	// The new Forms
	var $orgScripts;  	// The original JavaScripts
	var $newScripts;  	// The new JavaScripts
	var $conf;      	// TypoScript Configuration for this extension
	var $spamTarget = 'neverspam.html';   // target if spam is submitted

	function main (&$html, &$conf) {
        if ($conf['enable'] == 1 && strstr($html,'<form')) {
			// initialize - set class variables
			$this->init($html,$conf);
			if ($this->conf['jsCookie']) {
				$jsCookie = "<script type=\"text/javascript\">
					document.cookie = 'spamshield_tstamp_js=".time()."' ;  // the timestamp only showns when the page got last cached. So be careful!
					</script>";
            	$this->html = str_replace('</body>',$jsCookie.'</body>',$this->html);
            }
            // changes on $this->newForms
            for ($i = 0; $i < sizeof($this->newForms); $i++) {
                // Mark all forms that data submission even with GET is clearly visable:
				if (!$this->enableOff($this->newForms[$i],$this->conf['enable.']['off.'])) {
				    if ($this->conf['detectForm'] && $this->conf['detectForm.']['mark']) {
				        $this->markDataSubmission($this->newForms[$i]);
				    }
            		if ($this->conf['honeypot'] && !$this->enableOff($this->newForms[$i],$this->conf['honeypot.']['off.'])) {
	            		$this->honeypot($this->newForms[$i]);
	            	}
	            	if ($this->conf['javascript'] && !$this->enableOff($this->newForms[$i],$this->conf['javascript.']['off.'])) {
            			$this->javascript($this->newForms[$i]);
            		}
            		if ($this->conf['rename'] && !$this->enableOff($this->newForms[$i],$this->conf['rename.']['off.'])) {
						$this->rename($this->newForms[$i]);
	            	}
					if (class_exists('tx_sourceopt_pi1') && $this->conf['sourceopt'] == "form") {
			    		$tx_sourceopt_pi1 = t3lib_div::makeInstance('tx_sourceopt_pi1');
		      			$tx_sourceopt_pi1->main ($this->newForms[$i], $GLOBALS['TSFE']->tmpl->setup['config.']['sourceopt.']);
					}
	            }
            }
			// fill the changed forms back in $this->html
			$this->html = str_replace($this->orgForms,$this->newForms,$this->html);
			// fill the changed javaScripts back in $this->html
			if ($this->conf['rename'] && $this->conf['rename.']['javaScript']) {
				$this->html = str_replace($this->orgScripts,$this->newScripts,$this->html);
			}
			if (class_exists('tx_sourceopt_pi1') && $this->conf['sourceopt'] == "output") {
      			$tx_sourceopt_pi1 = t3lib_div::makeInstance('tx_sourceopt_pi1');
      			$tx_sourceopt_pi1->main ($this->html, $GLOBALS['TSFE']->tmpl->setup['config.']['sourceopt.']);
			}
		}            
	}
	
	#####################################################
	## Functions for initalizing                    #####
	#####################################################
	/**
	 * initialize
	 * set class variables
	 *
	 * @param	string      output html content
	 * @param   array       configuration array
	 * @return  array       all forms in $this->body
	 */
	function init(&$html,&$conf) {
		$this->html =& $html;
		$this->conf =& $conf;
        // get original forms
        $this->newForms = $this->orgForms = $this->getForms();
        // get Scripts
        if ($this->conf['rename.']['javaScript']) {
        	$this->newScripts = $this->orgScripts = $this->getScripts();
		}
	}
	
	/**
	 * get all forms out of $this->html
	 *
	 * @param	nothing
	 * @return  array       all forms in $this->body
	 */
	function getForms () {
    	$numberOfForms = preg_match_all ("/(?s)(<[ \n\r]*form[^>]*>.*?<[ \n\r]*\/form[^>]*>)/is", $this->html, $matches);
    	return $matches[0];
	}
	
	function getScripts () {
		$numberOfScripts = preg_match_all("/(?s)(<[ \n\r]*script[^>]*>.*?<[ \n\r]*\/script[^>]*>)/im", $this->html, $matches);
		return $matches[0];
	}
    
	/**
	 * regex rules for disabeling for single forms
	 *
	 * @param	string     the html form
	 * @param   array       config array with regex rules
	 * @return  boolean
	 */
	function enableOff($form,$conf) {
		if (is_array($conf)) {
			foreach($conf as $pattern) {
				if(preg_match($pattern,$form)) {
					return true;
				}
           	}
        }
		else {
			return false;
		}
	}
	#####################################################
	
	#####################################################
	## Functions for changing the forms             #####
	#####################################################

	/**
	 * Mark form with a hidden field that data submission even with GET is clearly fisable
	 *
	 * @param	nothing
	 * @return	nothing
	 */
	function markDataSubmission (&$form) {
		$form = str_replace('</form>',$this->conf['detectForm.']['typicalVars'].'</form>',$form);
	}

	/**
	 * java-script onclick will change the value of a form field
	 *
	 * @param	string		html code of the forms.
	 * @return	nothing
	 */
	function javascript (&$form) {
		$form = str_replace('</form>','<input type="hidden" name="'.$this->conf['javascript.']['fieldname'].'" value="'.$this->conf['javascript.']['false'].'"></form>',$form);
		$submitJavaScript = '  onclick="this.form.'.$this->conf['javascript.']['fieldname'].'.value=\''.$this->conf['javascript.']['true'].'\'" ';
		if (strstr($form,'type="submit"')) {
			$form = str_replace('type="submit"','type="submit"'.$submitJavaScript,$form);
		}
		elseif (strstr($form,'type=submit')) {
			$form = str_replace('type="submit"','type="image"'.$submitJavaScript,$form);
		}
		elseif (strstr($form,'type="image"')) {
			$form = str_replace('type="image"','type="image"'.$submitJavaScript,$form);
		}
		elseif (strstr($form,'type=image')) {
			$form = str_replace('type="image"','type="image"'.$submitJavaScript,$form);
		}
		else {
			$form = str_replace('</form>','<input type="submit"'.$submitJavaScript.'style="position: absolute; margin: 0 0 0 -9999px;"></form>',$form);
		}
	}

	/**
	 * include a honey pot
	 *
	 * @param	string		html code of the forms.
	 * @return	nothing
	 */
	function honeypot (&$form) {
		$inputs = $this->getInputs($form);
		$newInputs = $inputs;
	    if ($this->conf['honeypot.']['position'] == "rnd") {
        	foreach ($this->conf['honeypot.']['pots.'] as $honeyPot) {
	            $changePos = mt_rand(0,sizeof($newInputs)-1);
    	        if (mt_rand(0,1) == 1) {
					$newInputs[$changePos] = $honeyPot.$newInputs[$changePos];
				}
				else {
			    	$newInputs[$changePos] = $newInputs[$changePos].$honeyPot;
				}
			}
		}
		elseif ($this->conf['honeypot.']['position'] == 'end') {
            $newInputs[sizeof($newInputs)-1] = $newInputs[sizeof($newInputs)-1].implode('',$this->conf['honeypot.']['pots.']);
		}
		elseif ($this->conf['honeypot.']['position'] == 'start') {
			$newInputs[0] = implode('',$this->conf['honeypot.']['pots.']).$newInputs[0];
		}
		elseif ($this->conf['honeypot.']['position'] == 'start-end') {
			$i = 0;
			foreach ($this->conf['honeypot.']['pots.'] as $honeypot) {
			    if ($i%2) {
					$newInputs[0] = $honeypot.$newInputs[0];
				}
				else {
					$newInputs[sizeof($newInputs)-1] = $newInputs[sizeof($newInputs)-1].$honeypot;
				}
				$i++;
			}
		}
		$form = str_replace($inputs,$newInputs,$form);
	}
	
	/**
	 * renaming of all input fields (makes it hard for bots to figure out what the form is about)
	 *
	 * @param	string		html code of the forms.
	 * @return	nothing
	 */
	function rename (&$form) {
	    $inputs = $this->getInputs($form);
		$newInputs = $inputs;
		$renameArray = array();
		$newNames = array();
		$orgNames = array();
		# attention <input type="image" name="... empty / no array ..." will be submitted twice
		for ($i = 0; $i < sizeof($newInputs); $i++) {
            if (preg_match('/name\s*=\s*"([^"]*)"\s*/Usi',$newInputs[$i],$match)) {
				$orgName = $match[1];
				#$newName = 'spamshield['.$this->randStr(3).']';
				$newName = $this->randStr(3).$i;
				$newInputs[$i] = str_replace('name="'.$orgName.'"','name="'.$newName.'"',$newInputs[$i]);
				$orgNames[] = $orgName;
				$newNames[] = $newName;
				$renameArray[$newName] = $orgName;
				
			}
            elseif (preg_match('/name\s*=\s*([^"]*)\s*/Usi',$newInputs[$i],$match)) {
				$orgName = $match[1];
				#$newName = 'spamshield['.$this->randStr(3).']';
				$newName = $this->randStr(3).$i;
				$newInputs[$i] = str_replace('name='.$orgName.'','name="'.$newName.'"',$newInputs[$i]);
				$orgNames[] = $orgName;
				$newNames[] = $newName;
				$renameArray[$newName] = $orgName;
			}
		}
		# rename form fields
		$form = str_replace($inputs,$newInputs,$form);
		# include the rename key in the form
		$seriel = str_replace('"','###',serialize($renameArray));
		$form = str_replace('</form>','<input type="hidden" name="rename" value="'.$seriel.'"></form>',$form);
		# rename in form Java-Script
		$form = str_replace($this->wrapArray($orgNames,".","."),$this->wrapArray($newNames,".","."),$form);
		# rename java scripts
		if ($this->conf['rename.']['javaScript']) {
			$this->renameScripts($orgNames,$newNames);
		}
	}
	/* help function for above */
	function randStr($size) {
    	$result = "";
    	srand((double)microtime()*1000000);
    	for($i=0; $i < $size; $i++) {
      		$num = rand(48,120);
      		while (($num >= 58 && $num <= 64) || ($num >= 91 && $num <= 96)) {
         		$num = rand(48,120);
			}
      		$result .= chr($num);
    	}
    	return $result;
  	}
  	/* help function for above */
  	function renameScripts($orgNames,$newNames) {
  	    $orgNamesFinal = $this->wrapArray($orgNames,"'","'");
  	    $newNamesFinal = $this->wrapArray($newNames,"'","'");
  	    $orgNamesFinal = array_merge($orgNamesFinal,$this->wrapArray($orgNames,".","."));
  	    $newNamesFinal = array_merge($newNamesFinal,$this->wrapArray($newNames,".","."));
  	    $orgNamesFinal = array_merge($orgNamesFinal,$this->wrapArray($orgNames," "," "));
  	    $newNamesFinal = array_merge($newNamesFinal,$this->wrapArray($newNames," "," "));
		for ($i = 0; $i < sizeof($this->newScripts); $i++) {
		    $this->newScripts[$i] = str_replace($orgNamesFinal,$newNamesFinal,$this->newScripts[$i]);
		}
	}
	/* help function for above */
	function wrapArray($array,$wrapStart,$wrapStop) {
		for ($i = 0; $i < sizeof($array); $i++) {
			$array[$i] = $wrapStart.$array[$i].$wrapStop;
		}
		return $array;
	}

	/**
	 * get all input fields out of a form
	 * help function for rename and honeypots
	 *
	 * @param	string		html code of the form.
	 * @return	array       all input fields in the form
	 */
	function getInputs($form) {
	    $numberOfInputs = preg_match_all ("/(?s)(<[ \n\r]*input.*?[ \n\r]*[^>]*>)/is", $form, $matches);
        return $matches[0];
	}
	#####################################################

}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/spamshield/pi2/class.tx_spamshield_pi2.php"]){
        include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/spamshield/pi2/class.tx_spamshield_pi2.php"]);
}

?>