<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007  Dr. Ronald Steiner <Ronald.Steiner@googlemail.com>
*  All rights reserved
* 
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');

/**
 * Plugin 'spamshield' for the 'spamshield' extension.
 *
 * @author	 Dr. Ronald Steiner <Ronald.Steiner@googlemail.com>
 * @package	TYPO3
 * @subpackage	spamshield
 */
class tx_spamshield_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_spamshield_pi1';		            // Same as class name
	var $scriptRelPath = 'pi1/class.tx_spamshield_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'spamshield';	                    // The extension key.
	var $piVars;                                                // = t3lib_div::GPvar($this->prefixId[..])
	var $conf;                                                  // TS configuration array

	var $pi_checkCHash = true;               // for caching
	var $pi_USER_INT_obj = 0;                // = 0 => Cache = 1 => no Cache
	
	var $DoormanApiObj; // wt_doorman API Object
	
	var $spamReason = array();        // reason for spam: => match to errormsg
	var $errorMsg = array();      // error message

    
	/**
	 * The main method of the PlugIn
	 * 
	 * $this->conf: templateCode   	 
	 *
	 * @param	  string		The PlugIn content
	 * @param	  array		  The PlugIn configuration (TS)
	 * @return	string    The content that is displayed on the website
	 */
	function main($content,$conf)	{
		// initialise
	    $this->init($conf);                           
		// generate output
		$markerArray['###ERROR_ITEMS###'] = '';
		foreach ($this->errorMsg as $msg) {
		    $msgMarker['###ERROR_MSG###'] = $msg;
		    $markerArray['###ERROR_ITEMS###'] .= $this->cObj->substituteMarkerArray($this->conf['templateItem'], $msgMarker);
		}
		$markerArray['###BACKLINK###'] = t3lib_div::getIndpEnv('HTTP_REFERER');
		$output = $this->cObj->substituteMarkerArray($this->conf['template'], $markerArray);
		// output
		return $output;
	}

	/**
	 * Initialize the Plugin:
	 *
	 * @param	array		$conf: The PlugIn configuration
	 * @return	nothing
	 */
	function init($conf) {
		//-----------------------------------------------------------------
      	// Set Class-Variable: $this->conf
      	//-----------------------------------------------------------------
		$this->conf = $conf;
		// filling default settings
		if (!$this->conf['dbLog.']['pid']) {
	        $this->conf['dbLog.']['pid'] = 1;
		}
		$this->conf['template'] = $this->cObj->stdWrap($this->conf['template'],$this->conf['template.']);
		$this->conf['templateItem'] = $this->cObj->stdWrap($this->conf['templateItem'],$this->conf['templateItem.']);
      	//-----------------------------------------------------------------
      	
		//-----------------------------------------------------------------
      	// Set Class-Variable: $this->reason $this->errormsg
      	//-----------------------------------------------------------------
		if ($this->piVars['spamReason']) {
            $this->spamReason = explode(',',urldecode($this->piVars['spamReason']));
		}
		foreach ($this->spamReason as $reason) {
			list($type,$msg) = explode(".",$reason);
			if ($this->conf[$type.'.'][$msg]) {
        		$this->errorMsg[] = $this->cObj->stdWrap($this->conf[$type.'.'][$msg],$this->conf[$type.'.'][$msg.'.']);
			}
		}
        //-----------------------------------------------------------------
	}
    
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/spamshield/pi1/class.tx_spamshield_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/spamshield/pi1/class.tx_spamshield_pi1.php']);
}

?>
